#include <pthread.h>
#include "utils/threading.h"

condition::condition () : _is_signalled(false)
{
    pthread_cond_init(&_cond, NULL);
    pthread_mutex_init(&_mutex, NULL);
}

condition::~condition ()
{
    pthread_cond_destroy(&_cond);
    pthread_mutex_destroy(&_mutex);
}

void condition::signal ()
{
    pthread_mutex_lock(&_mutex);
    _is_signalled = true;
    pthread_cond_signal(&_cond);
    pthread_mutex_unlock(&_mutex);
}

void condition::wait_for ()    
{
    pthread_mutex_lock(&_mutex);
    
    while (!_is_signalled)
        pthread_cond_wait(&_cond, &_mutex);

    _is_signalled = false;
    
    pthread_mutex_unlock(&_mutex);
}
